//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <math.h>

#include "muParser.h"
using namespace mu;
#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;

double vars[9],expansion,contraction,norm_rng;
int iteration_count=0,iteration_limit,rand_tab[400],rand_int;
bool error=0;

char tekst0[999];
char tekst1[999];
char tekst2[999];
char tekst3[999];

Parser p;

double simplex[99][10];
/*
  simplex = new double*[Form1->StringGrid1->RowCount];
  for (int i=0; i<Form1->StringGrid1->RowCount ; i++)
  simplex[i] = new double[(Form1->StringGrid1->ColCount - 2)];
  int lowest=0;
*/

int check_int(TEdit *pole) {

  int counter = 0;

  sprintf(tekst0, "%s", pole->Text);

  if (pole->Text.Length()==0){
    return 0;
  }

  for (int i=0; i<pole->Text.Length(); i++) {

    if (tekst0[i] == '0' || tekst0[i] == '1' || tekst0[i] == '2' || tekst0[i] == '3' || tekst0[i] == '4' || tekst0[i] == '5' || tekst0[i] == '6' || tekst0[i] == '7' || tekst0[i] == '8' || tekst0[i] == '9') {
      counter++;
    }
  }

  if (counter == pole->Text.Length()){
    return 1;
  }
  else {
    pole->Text = "";
    return 0;
  }
}
int check_float(TEdit *pole) {

  int counter = 0;
  int przecinek = 0;
  int minus = 0;

  sprintf(tekst0, "%s", pole->Text);
  if ((tekst0[0] == '-' && pole->Text.Length()==1) || pole->Text.Length()==0){
    return 0;
  }

  for (int i=0; i<pole->Text.Length(); i++) {

    if (tekst0[0] == '-' || tekst0[i] == '0' || tekst0[i] == '1' || tekst0[i] == '2' || tekst0[i] == '3' || tekst0[i] == '4' || tekst0[i] == '5' || tekst0[i] == '6' || tekst0[i] == '7' || tekst0[i] == '8' || tekst0[i] == '9' || tekst0[i] == '.' || tekst0[i] == ',' ) {
      counter++;

      if ((tekst0[i] == '.' || tekst0[i] == ',') && !przecinek){
        przecinek++;
      }
      else if ((tekst0[i] == '.' || tekst0[i] == ',') && przecinek){
        pole->Text = "";
        return 0;
      }
      if (tekst0[i] == '-' && !minus){
        minus++;
      }
      else if (tekst0[i] == '-' && minus){
        pole->Text = "";
        return 0;
      }
    }
  }

  if ( (counter) && (counter == pole->Text.Length())){
    return 1;
  }
  else {
    pole->Text = "";
    return 0;
  }
}

double parse(int pkt) {

  double wart;

  p.DefineVar("x1", &simplex[pkt][0]);
  p.DefineVar("x2", &simplex[pkt][1]);
  p.DefineVar("x3", &simplex[pkt][2]);
  p.DefineVar("x4", &simplex[pkt][3]);
  p.DefineVar("x5", &simplex[pkt][4]);
  p.DefineVar("x6", &simplex[pkt][5]);
  p.DefineVar("x7", &simplex[pkt][6]);
  p.DefineVar("x8", &simplex[pkt][7]);
  p.DefineVar("x9", &simplex[pkt][8]);
  p.DefineVar("x0", &simplex[pkt][9]);

  sprintf(tekst1, "%s", Form1->Edit1->Text);


  try
  {
    error=0;
    p.SetExpr(tekst1);
    wart = p.Eval();
  }
  catch (mu::Parser::exception_type &e)
  {
    error=1;
    sprintf(tekst0, "%s", e.GetMsg());
    Application->MessageBox(tekst0,"Parse Error!", MB_OK | MB_ICONERROR);
  }

  return wart;
}

void przelicz(void) {
  for (int i=1; i<=Form1->StringGrid1->RowCount && !error; i++){
      simplex[i][Form1->StringGrid1->ColCount-2] = parse(i);
  }
}

void przepisz(void) {

  for (int i=1; i<=Form1->StringGrid1->RowCount; i++){

    for (int j=1; j<=Form1->StringGrid1->ColCount-1; j++){

      sprintf(tekst0, "%f", simplex[i][j-1]);
      Form1->StringGrid1->Cells[j][i] = tekst0;
    }
  }
}

void step(void){

  przelicz();
  int max = 1,min = 1,ma = 1;

  for (int i=1; i<=Form1->StringGrid1->RowCount-1; i++){
    if (simplex[i][Form1->StringGrid1->ColCount-2] > simplex[max][Form1->StringGrid1->ColCount-2]) {
      max = i;
    }
    if (simplex[i][Form1->StringGrid1->ColCount-2] < simplex[min][Form1->StringGrid1->ColCount-2]) {
      min = i;
    }
  }

  for (int i=1; i<=Form1->StringGrid1->RowCount-1; i++){
    if ((i != ma) && (simplex[i][Form1->StringGrid1->ColCount-2] > simplex[ma][Form1->StringGrid1->ColCount-2])) {
      ma = i;
    }
  }

  double avg[9],tmp[9];

  for (int i=0; i<=9;i++) {
    avg[i] = 0;
    tmp[9] = 0;
  }

  //sprintf(tekst0, "%d", max);
  //Application->MessageBox(tekst0,"Maksiu", MB_OK | MB_ICONERROR);

  for (int j=0; j<Form1->StringGrid1->ColCount-2; j++){

    for (int i=1; i<Form1->StringGrid1->RowCount; i++){

      if(i != max){
        avg[j] += simplex[i][j];
        //sprintf(tekst0, "%f", simplex[i][j]);
        //Application->MessageBox(tekst0,"rednia suma", MB_OK | MB_ICONERROR);
      }
    }
    avg[j]/=Form1->StringGrid1->RowCount-2;
    //sprintf(tekst0, "%f", avg[j]);
    //Application->MessageBox(tekst0,"rednia", MB_OK | MB_ICONERROR);
  }

  for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
    simplex[0][i] = avg[i] + Form1->Edit19->Text.ToDouble() * (avg[i] - simplex[max][i]);
    //sprintf(tekst0, "%f", simplex[0][i]);
   // Application->MessageBox(tekst0,"odbity", MB_OK | MB_ICONERROR);
  }

  double f_max, f_ma, f_min, f_ref;

    f_max = parse(max);
    f_ma = parse(ma);
    f_min = parse(min);
    f_ref = parse(0);



  if ( f_ref < f_min ) {
    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      tmp[i] = simplex[0][i];
    }

    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      simplex[0][i] = avg[i] + (Form1->Edit12->Text.ToDouble()) *(tmp[i] - avg[i]);
    }

    double f_exp;

      f_exp = parse(0);

    if (f_exp < f_ref) {
      for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
        simplex[max][i] = simplex[0][i];
      }
    }
    else {
      for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
        simplex[max][i] = tmp[i];
      }
    }
    Form1->Label22->Caption = "E";
    //Application->MessageBox("ekspansja","wartosc funkcji", MB_OK | MB_ICONERROR);

  }
  else if ( (f_min <= f_ref) && (f_ref < f_ma) ) {
    Form1->Label22->Caption = "r";
    //Application->MessageBox("nic","wartosc funkcji", MB_OK | MB_ICONERROR);
    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      simplex[max][i] = simplex[0][i];
    }
  }
  else if ( (f_ma <= f_ref) && (f_ref < f_max) ) {
    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      tmp[i] = simplex[max][i];
    }

    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      simplex[0][i] = avg[i] + Form1->Edit13->Text.ToDouble() *(tmp[i] - avg[i]);
    }

    double f_kont;

      f_kont = parse(0);

    if (f_kont < f_ref) {
      for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
        simplex[max][i] = simplex[0][i];
      }
    }
    else {
      for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
        simplex[max][i] = tmp[i];
      }
    }
    Form1->Label22->Caption = "K";
    //Application->MessageBox("kont","wartosc funkcji", MB_OK | MB_ICONERROR);

  }
  else if ( f_max <= f_ref ) {
    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      tmp[i] = simplex[max][i];
    }

    for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
      simplex[max][i] = avg[i] + Form1->Edit13->Text.ToDouble() *(tmp[i] - avg[i]);
    }
    Form1->Label22->Caption = "K'";
    //Application->MessageBox("kontr2","wartosc funkcji", MB_OK | MB_ICONERROR);
  }
  else {
  Application->MessageBox("zonk","zonk", MB_OK | MB_ICONERROR);

  }

  //sprintf(tekst0, "%f", tmp);
  //Application->MessageBox(tekst0,"wartosc funkcji", MB_OK | MB_ICONERROR);

}
double opt() {

  double avg[9],tmp[9];

  for (int i=0; i<=9;i++) {
    avg[i] = 0;
  }

  for (int j=0; j<Form1->StringGrid1->ColCount-2; j++){

    for (int i=1; i<=Form1->StringGrid1->RowCount; i++){

      avg[j] += simplex[i][j];
    }
    avg[j]/=Form1->StringGrid1->RowCount-2;
  }

  for (int i=0; i<Form1->StringGrid1->ColCount-2; i++) {
    simplex[0][i] = avg[i];

  }

  return parse(0);


}
double rnd(double dn, double up){

  return dn+((float)rand_tab[++rand_int]/100000)*(up-dn);
}

void reset() {

  error=0;
  iteration_count = 0;
  Form1->Label27->Caption = iteration_count;
  if (!Form1->Edit15->Text.IsEmpty()){
    Form1->ProgressBar1->Position = iteration_count % Form1->Edit15->Text.ToInt();
  }
  Form1->Label21->Caption = "";

}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  TForm1::Edit1->Text = "x1^2+x2^2+x1*x2+2";
  Form1->StringGrid1->ColWidths[0] = 20;
  Form1->StringGrid1->RowHeights[0] = 20;
  Form1->Label14->Caption = "Version 0.9 (22-01-2006)";

}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  reset();
  double wartosc = parse(Form1->CSpinEdit1->Value);

  sprintf(tekst0, "%s", FloatToStr(wartosc));
  TForm1::Label19->Caption = tekst0;
  //  Application->MessageBox(tekst0,"Debug Info", MB_OK | MB_ICONEXCLAMATION);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label13Click(TObject *Sender)
{
  Application->MessageBox("Version 0.1 (uses MuParser and kupaKupa)","Debug Info", MB_OK | MB_ICONEXCLAMATION);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Form2->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1Change(TObject *Sender)
{
  reset();
  if (Form1->Edit1->Text.AnsiPos("x1")) {
    Form1->StringGrid1->ColCount = 3;
    Form1->StringGrid1->Cells[1][0] = "x1";
    Form1->Edit2->Enabled = true;
    Form1->Edit20->Enabled = true;
    Form1->Edit30->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x2")) {
    Form1->StringGrid1->ColCount = 4;
    Form1->StringGrid1->Cells[2][0] = "x2";
    Form1->Edit3->Enabled = true;
    Form1->Edit21->Enabled = true;
    Form1->Edit31->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x3")) {
    Form1->StringGrid1->ColCount = 5;
    Form1->StringGrid1->Cells[3][0] = "x3";
    Form1->Edit4->Enabled = true;
    Form1->Edit22->Enabled = true;
    Form1->Edit32->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x4")) {
    Form1->StringGrid1->ColCount = 6;
    Form1->StringGrid1->Cells[4][0] = "x4";
    Form1->Edit5->Enabled = true;
    Form1->Edit23->Enabled = true;
    Form1->Edit33->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x5")) {
    Form1->StringGrid1->ColCount = 7;
    Form1->StringGrid1->Cells[5][0] = "x5";
    Form1->Edit6->Enabled = true;
    Form1->Edit24->Enabled = true;
    Form1->Edit34->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x6")) {
    Form1->StringGrid1->ColCount = 8;
    Form1->StringGrid1->Cells[6][0] = "x6";
    Form1->Edit7->Enabled = true;
    Form1->Edit25->Enabled = true;
    Form1->Edit35->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x7")) {
    Form1->StringGrid1->ColCount = 9;
    Form1->StringGrid1->Cells[7][0] = "x7";
    Form1->Edit8->Enabled = true;
    Form1->Edit26->Enabled = true;
    Form1->Edit36->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x8")) {
    Form1->StringGrid1->ColCount = 10;
    Form1->StringGrid1->Cells[8][0] = "x8";
    Form1->Edit9->Enabled = true;
    Form1->Edit27->Enabled = true;
    Form1->Edit37->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x9")) {
    Form1->StringGrid1->ColCount = 11;
    Form1->StringGrid1->Cells[9][0] = "x9";
    Form1->Edit10->Enabled = true;
    Form1->Edit28->Enabled = true;
    Form1->Edit38->Enabled = true;
  if (Form1->Edit1->Text.AnsiPos("x0")) {
    Form1->StringGrid1->ColCount = 12;
    Form1->StringGrid1->Cells[10][0] = "x0";
    Form1->Edit11->Enabled = true;
    Form1->Edit29->Enabled = true;
    Form1->Edit39->Enabled = true;
  }
  else{Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit6->Enabled = false;Form1->Edit24->Enabled = false;Form1->Edit34->Enabled = false;Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit5->Enabled = false;Form1->Edit23->Enabled = false;Form1->Edit33->Enabled = false;Form1->Edit6->Enabled = false;Form1->Edit24->Enabled = false;Form1->Edit34->Enabled = false;Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit4->Enabled = false;Form1->Edit22->Enabled = false;Form1->Edit32->Enabled = false;Form1->Edit5->Enabled = false;Form1->Edit23->Enabled = false;Form1->Edit33->Enabled = false;Form1->Edit6->Enabled = false;Form1->Edit24->Enabled = false;Form1->Edit34->Enabled = false;Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit3->Enabled = false;Form1->Edit21->Enabled = false;Form1->Edit31->Enabled = false;Form1->Edit4->Enabled = false;Form1->Edit22->Enabled = false;Form1->Edit32->Enabled = false;Form1->Edit5->Enabled = false;Form1->Edit23->Enabled = false;Form1->Edit33->Enabled = false;Form1->Edit6->Enabled = false;Form1->Edit24->Enabled = false;Form1->Edit34->Enabled = false;Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}
  }
  else{Form1->Edit2->Enabled = false;Form1->Edit20->Enabled = false;Form1->Edit30->Enabled = false;Form1->Edit3->Enabled = false;Form1->Edit21->Enabled = false;Form1->Edit31->Enabled = false;Form1->Edit4->Enabled = false;Form1->Edit22->Enabled = false;Form1->Edit32->Enabled = false;Form1->Edit5->Enabled = false;Form1->Edit23->Enabled = false;Form1->Edit33->Enabled = false;Form1->Edit6->Enabled = false;Form1->Edit24->Enabled = false;Form1->Edit34->Enabled = false;Form1->Edit7->Enabled = false;Form1->Edit25->Enabled = false;Form1->Edit35->Enabled = false;Form1->Edit8->Enabled = false;Form1->Edit26->Enabled = false;Form1->Edit36->Enabled = false;Form1->Edit9->Enabled = false;Form1->Edit27->Enabled = false;Form1->Edit37->Enabled = false;Form1->Edit10->Enabled = false;Form1->Edit28->Enabled = false;Form1->Edit38->Enabled = false;Form1->Edit11->Enabled = false;Form1->Edit29->Enabled = false;Form1->Edit39->Enabled = false;}

  Form1->Edit18->Text = 2*(Form1->StringGrid1->ColCount-2);
  Form1->StringGrid1->Cells[Form1->StringGrid1->ColCount-1][0] = "f(x)";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit2)) {
    simplex[Form1->CSpinEdit1->Value][0] = TForm1::Edit2->Text.ToDouble();
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit3)) {
    simplex[Form1->CSpinEdit1->Value][1] = StrToFloat(TForm1::Edit3->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit4)) {
    simplex[Form1->CSpinEdit1->Value][2] = StrToFloat(TForm1::Edit4->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit5Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit5)) {
    simplex[Form1->CSpinEdit1->Value][3] = StrToFloat(TForm1::Edit5->Text);
  }przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit6Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit6)) {
    simplex[Form1->CSpinEdit1->Value][4] = StrToFloat(TForm1::Edit6->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit7Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit7)) {
    simplex[Form1->CSpinEdit1->Value][5] = StrToFloat(TForm1::Edit7->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit8Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit8)) {
    simplex[Form1->CSpinEdit1->Value][6] = StrToFloat(TForm1::Edit8->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit9Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit9)) {
    simplex[Form1->CSpinEdit1->Value][7] = StrToFloat(TForm1::Edit9->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit10Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit10)) {
    simplex[Form1->CSpinEdit1->Value][8] = StrToFloat(TForm1::Edit10->Text);
  }
  przelicz();
  przepisz();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit11Change(TObject *Sender)
{
  reset();
  if (check_float(Form1->Edit11)) {
    simplex[Form1->CSpinEdit1->Value][9] = StrToFloat(TForm1::Edit11->Text);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit12Change(TObject *Sender)
{
  if (check_float(Form1->Edit12)) {
    expansion = StrToFloat(TForm1::Edit12->Text);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit13Change(TObject *Sender)
{
  if (check_float(Form1->Edit13)) {
    contraction = StrToFloat(TForm1::Edit13->Text);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit14Change(TObject *Sender)
{
  if (check_float(Form1->Edit14)) {
    norm_rng = StrToFloat(TForm1::Edit14->Text);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit15Change(TObject *Sender)
{
  if (check_int(Form1->Edit15)) {
    iteration_limit = StrToInt(TForm1::Edit15->Text);
  }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Application->MessageBox("Solution plotting will be implemented in further version of this program","Plotter", MB_OK | MB_ICONWARNING);
  if (Form1->StringGrid1->ColCount != 4) {
    Application->MessageBox("Plotting works only for functions with only two variables!","Plotter", MB_OK | MB_ICONWARNING);
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

int conditions() {

    int check=0;

    for (int j=0; j<Form1->StringGrid1->ColCount-2; j++){

      for (int i=1; i<Form1->StringGrid1->RowCount; i++){

        for (int k=1; k<=Form1->StringGrid1->RowCount; k++){

          int l=k%(Form1->StringGrid1->RowCount-1);
          if (l==0) l=1;

          if (sqrt((simplex[i][j] - simplex[l][j])*(simplex[i][j] - simplex[l][j])) > Form1->Edit14->Text.ToDouble())
            check++;

        }
      }
    }


  return check;

}

double avg(int col) {

      double suma = 0;

      for (int i=1; i<Form1->StringGrid1->RowCount; i++){

        suma += simplex[i][col];
      }

  return suma/(Form1->StringGrid1->RowCount-1);
}


void __fastcall TForm1::Button4Click(TObject *Sender)
{
   if (Form1->Edit18->Text.ToInt() < Form1->StringGrid1->ColCount-1){
     Form1->Edit18->Text = Form1->StringGrid1->ColCount-1;
   }

  Form1->ProgressBar1->Max = Form1->Edit15->Text.ToInt();
  int limit = Form1->Edit15->Text.ToInt();
  do {
    step();
    iteration_count++;
    Form1->Label27->Caption = iteration_count;
    limit--;
    Form1->ProgressBar1->Position = iteration_count % Form1->Edit15->Text.ToInt();
  } while ((conditions() || (Form1->CheckBox1->State != 1) ) && limit);

  Form1->CSpinEdit1->Value = 1;
  
  if (!conditions()) {
    String abc = Format("znaleziono optimum %.4f\nw punkcie (", ARRAYOFCONST((avg(Form1->StringGrid1->ColCount-2))));

    for (int j=0; j<Form1->StringGrid1->ColCount-2; j++){
      abc.Insert(Format("%.3f", ARRAYOFCONST((avg(j)))), abc.Length()+1);
      if(j != Form1->StringGrid1->ColCount-3){
        abc.Insert("; ", abc.Length()+1);
      }
    }

    abc.Insert(")", abc.Length()+1);
    sprintf(tekst0,"%s", abc);
    TForm1::Label21->Caption = tekst0;
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
     if (Form1->Edit18->Text.ToInt() < Form1->StringGrid1->ColCount-1){
     Form1->Edit18->Text = Form1->StringGrid1->ColCount-1;
   }

  iteration_count++;
  Form1->Label27->Caption = iteration_count;
  Form1->ProgressBar1->Position = iteration_count % Form1->Edit15->Text.ToInt();
  step();
  Form1->CSpinEdit1->Value = 1;

  if (!conditions()) {
    String abc = Format("znaleziono optimum %.4f\nw punkcie (", ARRAYOFCONST((avg(Form1->StringGrid1->ColCount-2))));

    for (int j=0; j<Form1->StringGrid1->ColCount-2; j++){
      abc.Insert(Format("%.3f", ARRAYOFCONST((avg(j)))), abc.Length()+1);
      if(j != Form1->StringGrid1->ColCount-3){
        abc.Insert("; ", abc.Length()+1);
      }
    }
    abc.Insert(")", abc.Length()+1);
    sprintf(tekst0,"%s", abc);
    TForm1::Label21->Caption = tekst0;
  }
  przelicz();
  przepisz();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  reset();

   for (int i = 0; i <= ((StringGrid1->RowCount-1) * (Form1->StringGrid1->ColCount-2)); i++) {
     rand_int=0;
     rand_tab[i] = random(100000);
   }

  for(int i=1; i<StringGrid1->RowCount && !error ;i++) {

    Form1->CSpinEdit1->Value = i;

    if (Form1->Edit2->Enabled == true) {
      if (Edit20->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit30->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit2->Text = rnd(Form1->Edit20->Text.ToDouble(),Form1->Edit30->Text.ToDouble());
    }
    if (Form1->Edit3->Enabled == true) {
      if (Edit21->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit31->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit3->Text = rnd(Form1->Edit21->Text.ToDouble(),Form1->Edit31->Text.ToDouble());
    }
    if (Form1->Edit4->Enabled == true) {
      if (Edit22->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit32->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit4->Text = rnd(Form1->Edit22->Text.ToDouble(),Form1->Edit32->Text.ToDouble());
    }
    if (Form1->Edit5->Enabled == true) {
      if (Edit23->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit33->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit5->Text = rnd(Form1->Edit23->Text.ToDouble(),Form1->Edit33->Text.ToDouble());
    }
    if (Form1->Edit6->Enabled == true) {
      if (Edit24->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit34->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit6->Text = rnd(Form1->Edit24->Text.ToDouble(),Form1->Edit34->Text.ToDouble());
    }
    if (Form1->Edit7->Enabled == true) {
      if (Edit25->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit35->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit7->Text = rnd(Form1->Edit25->Text.ToDouble(),Form1->Edit35->Text.ToDouble());
    }
    if (Form1->Edit8->Enabled == true) {
      if (Edit26->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit36->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit8->Text = rnd(Form1->Edit26->Text.ToDouble(),Form1->Edit36->Text.ToDouble());
    }
    if (Form1->Edit9->Enabled == true) {
      if (Edit27->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit37->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit9->Text = rnd(Form1->Edit27->Text.ToDouble(),Form1->Edit37->Text.ToDouble());
    }
    if (Form1->Edit10->Enabled == true) {
      if (Edit28->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit38->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit10->Text = rnd(Form1->Edit28->Text.ToDouble(),Form1->Edit38->Text.ToDouble());
    }
    if (Form1->Edit11->Enabled == true) {
      if (Edit29->Text.IsEmpty()) Edit20->Text = 0;
      if (Edit39->Text.IsEmpty()) Edit30->Text = 0;
      TForm1::Edit11->Text = rnd(Form1->Edit29->Text.ToDouble(),Form1->Edit39->Text.ToDouble());
    }
  }
  Form1->CSpinEdit1->Value = 1;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Edit18Change(TObject *Sender)
{
  if (check_int(Form1->Edit18) && Form1->Edit18->Text.ToInt() > 99) {
    Form1->Edit18->Text = "99";
  }

  if (check_int(Form1->Edit18) && Form1->Edit18->Text.ToInt() > 1) {
    Form1->StringGrid1->RowCount = StrToInt(Form1->Edit18->Text)+1;
    Form1->CSpinEdit1->MaxValue = StrToInt(Form1->Edit18->Text);
    for (int i=1; i<=StrToInt(Form1->Edit18->Text); i++) {
      Form1->StringGrid1->Cells[0][i] = i;
    }
    przepisz();
  }

}
//---------------------------------------------------------------------------

void refresh_points(void) {

    if (Form1->Edit2->Enabled == true) {

      Form1->Edit2->Text = simplex[Form1->CSpinEdit1->Value][0];
    }
    if (Form1->Edit3->Enabled == true) {
      Form1->Edit3->Text = simplex[Form1->CSpinEdit1->Value][1];
    }
    if (Form1->Edit4->Enabled == true) {
      Form1->Edit4->Text = simplex[Form1->CSpinEdit1->Value][2];
    }
    if (Form1->Edit5->Enabled == true) {
      Form1->Edit5->Text = simplex[Form1->CSpinEdit1->Value][3];
    }
    if (Form1->Edit6->Enabled == true) {
      Form1->Edit6->Text = simplex[Form1->CSpinEdit1->Value][4];
    }
    if (Form1->Edit7->Enabled == true) {
      Form1->Edit7->Text = simplex[Form1->CSpinEdit1->Value][5];
    }
    if (Form1->Edit8->Enabled == true) {
      Form1->Edit8->Text = simplex[Form1->CSpinEdit1->Value][6];
    }
    if (Form1->Edit9->Enabled == true) {
      Form1->Edit9->Text = simplex[Form1->CSpinEdit1->Value][7];
    }
    if (Form1->Edit10->Enabled == true) {
      Form1->Edit10->Text = simplex[Form1->CSpinEdit1->Value][8];
    }
    if (Form1->Edit11->Enabled == true) {
      Form1->Edit11->Text = simplex[Form1->CSpinEdit1->Value][9];
    }
}

void __fastcall TForm1::CSpinEdit1Change(TObject *Sender)
{
  refresh_points();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  reset();
   for (int i = 0; i <= Form1->StringGrid1->ColCount-2; i++) {
     rand_int=0;
     rand_tab[i] = random(100000);
   }

    if (Form1->Edit2->Enabled == true) {
      TForm1::Edit2->Text = rnd(Form1->Edit20->Text.ToDouble(),Form1->Edit30->Text.ToDouble());
    }
    if (Form1->Edit3->Enabled == true) {
      TForm1::Edit3->Text = rnd(Form1->Edit21->Text.ToDouble(),Form1->Edit31->Text.ToDouble());
    }
    if (Form1->Edit7->Enabled == true) {
      TForm1::Edit7->Text = rnd(Form1->Edit25->Text.ToDouble(),Form1->Edit35->Text.ToDouble());
    }
    if (Form1->Edit8->Enabled == true) {
      TForm1::Edit8->Text = rnd(Form1->Edit26->Text.ToDouble(),Form1->Edit36->Text.ToDouble());
    }
    if (Form1->Edit9->Enabled == true) {
      TForm1::Edit9->Text = rnd(Form1->Edit27->Text.ToDouble(),Form1->Edit37->Text.ToDouble());
    }
    if (Form1->Edit10->Enabled == true) {
      TForm1::Edit10->Text = rnd(Form1->Edit28->Text.ToDouble(),Form1->Edit38->Text.ToDouble());
    }
    if (Form1->Edit11->Enabled == true) {
      TForm1::Edit11->Text = rnd(Form1->Edit29->Text.ToDouble(),Form1->Edit39->Text.ToDouble());
    }

    if (Form1->CSpinEdit1->Value >= StringGrid1->RowCount-1) {
      Form1->CSpinEdit1->Value = 1;
    }
    else {
      Form1->CSpinEdit1->Value++;
    }
}
//---------------------------------------------------------------------------







void __fastcall TForm1::Edit20Change(TObject *Sender)
{
  check_float(Form1->Edit20);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit21Change(TObject *Sender)
{
  check_float(Form1->Edit21);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit22Change(TObject *Sender)
{
  check_float(Form1->Edit22);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit23Change(TObject *Sender)
{
  check_float(Form1->Edit23);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit24Change(TObject *Sender)
{
  check_float(Form1->Edit24);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit25Change(TObject *Sender)
{
  check_float(Form1->Edit25);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit26Change(TObject *Sender)
{
  check_float(Form1->Edit26);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit27Change(TObject *Sender)
{
  check_float(Form1->Edit27);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit28Change(TObject *Sender)
{
  check_float(Form1->Edit28);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit29Change(TObject *Sender)
{
  check_float(Form1->Edit29);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit30Change(TObject *Sender)
{
  check_float(Form1->Edit30);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit31Change(TObject *Sender)
{
  check_float(Form1->Edit31);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit32Change(TObject *Sender)
{
  check_float(Form1->Edit32);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit33Change(TObject *Sender)
{
  check_float(Form1->Edit33);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit34Change(TObject *Sender)
{
  check_float(Form1->Edit34);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit35Change(TObject *Sender)
{
  check_float(Form1->Edit35);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit36Change(TObject *Sender)
{
  check_float(Form1->Edit36);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit37Change(TObject *Sender)
{
  check_float(Form1->Edit37);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit38Change(TObject *Sender)
{
  check_float(Form1->Edit38);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit39Change(TObject *Sender)
{
  check_float(Form1->Edit39);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label14Click(TObject *Sender)
{
  Form3->Show();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Label14Enter(TObject *Sender)
{
  Form1->Label14->Font->Style = TFontStyles()<< fsUnderline;
  Form1->Label14->Font->Color = clBlue;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label14Leave(TObject *Sender)
{
  Form1->Label14->Font->Style = TFontStyles() << -fsUnderline;
  Form1->Label14->Font->Color = clGreen;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label22Enter(TObject *Sender)
{
 Form1->Label22->Font->Color = clRed;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label22Leave(TObject *Sender)
{
 Form1->Label22->Font->Color = clSilver;
}
//---------------------------------------------------------------------------


