function [grad,H]=wz_gr_po(x,y,nr,par)

if (nr==1),			% kwadratowa
	grad(1)=2*par(1)*x+par(3)*y+par(4);
	grad(2)=2*par(2)*y+par(3)*x+par(5);
	H(1,1)=2*par(1);
	H(1,2)=par(3);
	H(2,1)=par(3);
	H(2,2)=2*par(2);	
	grad=grad';
elseif (nr==2),			% Bananoida
	grad(1)=-4*par(1)*(y-x.^2)*x-2*par(2)*(par(3)-x);
	grad(2)=2*par(1)*(y-x.^2);
	H(1,1)=-4*par(1)+12*(x.^2)*par(1)+2*par(2);
	H(1,2)=-4*par(1)*x;
	H(2,1)=-4*par(1)*x;
	H(2,2)=2*par(1);
	grad=grad';
elseif (nr==3),			% sin-cos
	grad(1)=2*par(1)*x+2*par(3)*cos(x.^2).*x;
	grad(2)=2*par(2)*y-2*par(4)*sin(y.^2).*y;
	H(1,1)=2*par(1)+2*par(3)*cos(x.^2)+4*par(3)*(x.^2)*sin(x.^2);
	H(1,2)=0;
	H(2,1)=0;
	H(2,2)=2*par(2)-2*par(4)*sin(y.^2)-4*par(4)*(y.^2)*cos(y.^2);
	grad=grad';
elseif (nr==4),			% nawiasy do n,m
	grad(1)=par(1)*par(3)*(par(1)*x-par(2)).^(par(3)-1);
	grad(2)=par(4)*par(6)*(par(4)*y-par(5)).^(par(6)-1);
	H(1,1)=(par(1)^2)*par(3)*(par(3)-1)*(par(1)*x-par(2)).^(par(3)-2);
	H(1,2)=0;
	H(2,1)=0;
	H(2,2)=(par(4)^2)*par(6)*(par(6)-1)*(par(4)*y-par(5)).^(par(6)-2);
	grad=grad';
elseif (nr==5),			% testowa
	grad(1)=4*((x-2).^3)+2*(x-2*y);
	grad(2)=-4*(x-2*y);

	H(1,1)=12*(x-2).^2+2;
	H(1,2)=-4;
	H(2,1)=-4;
	H(2,2)=8;
	grad=grad';
end

	