% 	MINIMALIZACJA FUNKCJI JEDNEJ ZMIENNEJ
%
%	METODA POCHODNEJ
%
%	Skadnia:	[Mat minf iter]=grad_pro(x0,d,l,fun,par)
%
%	Wielkosci wyjsciowe:
%		Mat - macierz o wymiarach (n,4) gdzie: n - il. krokow
%			
%		Mat= |	1	x1	f(x1)	f'(x1)	|
%		     |  .	.	.	.	|
%		     |	n	xn	f(xn)	f'(xn)	|
%		minf = [x* y*]
%		iter - ilosc wykonanych iteracji
%
%	Wielkosci wejsciowe:
%		x0 - funkt poczatkowy
%		d - wsp. korekcji <1
%		l - dokladnosc obliczen

function [Mat,minf,iter,F_iter]=grad_pro(x0,d,l,fun,par)
	global err;
	x(1)=x0;
	Mat(1,1)=1;
	Mat(1,2)=x(1);
	Mat(1,3)=eval([fun '(par,x(1))']);
	Mat(1,5)=d;
	
	for i=2:999,
		x(i)=x(i-1)-d*pochodna(fun,x(i-1),par);
		Mat(i,1)=i;
		Mat(i,2)=x(i);
		Mat(i,3)=eval([fun '(par,x(i))']);
		Mat(i-1,4)=pochodna(fun,x(i-1),par);
		Mat(i,5)=d;
		if (abs(x(i)-x(i-1))<l),
			Mat(i,4)=pochodna(fun,x(i),par);
			minf=[x(i) eval([fun '(par,x(i))'])];
			iter=i;
			F_iter=2*iter;
			break;

		end			
		if (i>3),
			if (abs(x(i)-x(i-2))<l),
				d=d/2;
			end
		end
	end
	if (i>999),
		err=2;
		save err %error
		blad('Nie znaleziono minimum !','Przekroczono dopuszczaln ilo iteracji.',1);
		minf=[x(i) eval([fun '(par,x(i))'])];
		F_iter=2*i;
		iter=1000;
	end	
	if (minf(2)>Mat(1,3)),
		blad('Nie znaleziono minimum !','Nieprawidowe parametry. Zmniejsz warto alfa',3);
		err=3;
		save err %error
	end