% 	MINIMALIZACJA FUNKCJI JEDNEJ ZMIENNEJ
%
%	***** METODA NEWTONA *****
%
%
%	Wieloksci wyjsciowe: 
%		Mat - macierz o wymiarach (n,9)	gdzie: n - il. krokow
%
%		Mat=| 	1	t1	f(t1)	f'(t1) 	f''(t1) |
%		    |	.	.	.	. 	.   	|
%		    |	n	tn	f(tn)	f'(tn) 	f''(tn) |
%
%		minf=[t*,f(t*)]	
%		iter - ilosc wykonanych iteracji
%
%	Wielkosci wejsciowe:
%		l	- warunek stopu:   b-a < l
%		fun	- nazwa funkci ktora badamy np. 'f1'
%			  gdzie: f1 jest funkcja postaci y=f1(x)
%

function [Mat,minf,iter,F_iter]=newton(a,l,fun,par)
x(1)=a;
for i=1:50,
	fx=pochodna(fun,x(i),par);
	fxx=pochodn2(fun,x(i),par);
	x(i+1)=x(i)-fx/fxx;
	Mat(i,1)=i;
	Mat(i,2)=x(i);
	Mat(i,3)=eval([fun '(par,x(i))']);
	Mat(i,4)=fx;
	Mat(i,5)=fxx;
	if abs(x(i+1)-x(i))<l,
		break
	end
end
Mat(i+1,1)=i+1;
Mat(i+1,2)=x(i+1);
Mat(i+1,3)=eval([fun '(par,x(i+1))']);
Mat(i+1,4)=pochodna(fun,x(i+1),par);
Mat(i+1,5)=pochodn2(fun,x(i+1),par);
fx=eval([fun '(par,x(i+1))']);
iter=i;
F_iter=iter*5;
minf=[x(i+1), fx];